Unit aer4e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure aer4e(N :Integer; var EPS1 :Extended; var D :Array of Extended;
                var E :Array of Extended; var E2 :Array of Extended;
                var LB :Extended; var UB :Extended; MM :Integer;
                var M :Integer; var W :Array of Extended;
                var IND :Array of Integer; var IERR :Integer;
                var RV4 :Array of Extended; var RV5 :Array of Extended);

implementation

procedure aer4e(N :Integer; var EPS1 :Extended; var D :Array of Extended;
                var E :Array of Extended; var E2 :Array of Extended;
                var LB :Extended; var UB :Extended; MM :Integer;
                var M :Integer; var W :Array of Extended;
                var IND :Array of Integer; var IERR :Integer;
                var RV4 :Array of Extended; var RV5 :Array of Extended);
var
I,J,K,L,P,Q,R,S,II,M1,M2,TAG,ISTURM :Integer;
U,V,T1,T2,XU,X0,X1,MACHEP :Extended;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32;
begin
{  ********** }
MACHEP := SYS051;
IERR := 0;
TAG := 0;
T1 := LB;
T2 := UB;
for I:=1 to N do
 begin
{  ********** }
  if ( I = 1 ) 
   then goto _1;
  if ( Abs(E[I-1]) > MACHEP*(Abs(D[I-1])+Abs(D[I-2])) ) 
   then goto _2;
_1:
  E2[I-1] := 0.0e0;
_2:
 end;
{ **********}
P := 1;
Q := N;
X1 := UB;
ISTURM := 1;
goto _17;
_3:
M := S;
X1 := LB;
ISTURM := 2;
goto _17;
_4:
M := M-S;
if ( M > MM ) 
 then goto _31;
Q := 0;
R := 0;
{  ********** }
_5:
if ( R = M ) 
 then goto _32;
TAG := TAG+1;
P := Q+1;
XU := D[P-1];
X0 := D[P-1];
U := 0.0e0;
for Q:=P to N do
 begin
  X1 := U;
  U := 0.0e0;
  V := 0.0e0;
  if ( Q = N ) 
   then goto _6;
  U := Abs(E[Q+0]);
  V := E2[Q+0];
_6:
  XU := EMin1(D[Q-1]-(X1+U),XU);
  X0 := EMax1(D[Q-1]+(X1+U),X0);
  if ( V = 0.0e0 ) 
   then goto _8;
_7:
 end;
_8:
X1 := EMax1(Abs(XU),Abs(X0))*MACHEP;
if ( EPS1 <= 0.0e0 ) 
 then EPS1 := -X1;
if ( P <> Q ) 
 then goto _9;
{  ********** }
if ( T1 > D[P-1] ) or ( D[P-1] >= T2 ) 
 then goto _30;
M1 := P;
M2 := P;
RV5[P-1] := D[P-1];
goto _25;
_9:
X1 := X1*(Q-P+1);
LB := EMax1(T1,XU-X1);
UB := EMin1(T2,X0+X1);
X1 := LB;
ISTURM := 3;
goto _17;
_10:
M1 := S+1;
X1 := UB;
ISTURM := 4;
goto _17;
_11:
M2 := S;
if ( M1 > M2 ) 
 then goto _30;
{  ********** }
X0 := UB;
ISTURM := 5;
for I:=M1 to M2 do
 begin
  RV5[I-1] := UB;
  RV4[I-1] := LB;
_12:
 end;
{ **********}
K := M2;
_13:
XU := LB;
{  ********** }
for II:=M1 to K do
 begin
  I := M1+K-II;
  if ( XU >= RV4[I-1] ) 
   then goto _14;
  XU := RV4[I-1];
  goto _15;
_14:
 end;
_15:
if ( X0 > RV5[K-1] ) 
 then X0 := RV5[K-1];
{  ********** }
_16:
X1 := (XU+X0)*0.5e0;
if ( (X0-XU) <= (2.e0*MACHEP*(Abs(XU)+Abs(X0))+Abs(EPS1)) )
 then goto _24;
{  ********** }
_17:
S := P-1;
U := 1.0e0;
for I:=P to Q do
 begin
  if ( U <> 0.0e0 ) 
   then goto _18;
  V := Abs(E[I-1])/MACHEP;
  if ( E2[I-1] = 0.0e0 ) 
   then V := 0.0e0;
  goto _19;
_18:
  V := E2[I-1]/U;
_19:
  U := D[I-1]-X1-V;
  if ( U < 0.0e0 ) 
   then S := S+1;
_20:
 end;
case ISTURM of
 1: goto _3;
 2: goto _4;
 3: goto _10;
 4: goto _11;
 5: goto _21;
end;
{  ********** }
_21:
if ( S >= K ) 
 then goto _23;
XU := X1;
if ( S >= M1 ) 
 then goto _22;
RV4[M1-1] := X1;
goto _16;
_22:
RV4[S+0] := X1;
if ( RV5[S-1] > X1 ) 
 then RV5[S-1] := X1;
goto _16;
_23:
X0 := X1;
goto _16;
{  ********** }
_24:
RV5[K-1] := X1;
K := K-1;
if ( K >= M1 ) 
 then goto _13;
{  ********** }
_25:
S := R;
R := R+M2-M1+1;
J := 1;
K := M1;
for L:=1 to R do
 begin
  if ( J > S ) 
   then goto _27;
  if ( K > M2 ) 
   then goto _30;
  if ( RV5[K-1] >= W[L-1] ) 
   then goto _28;
  for II:=J to S do
   begin
    I := L+S-II;
    W[I+0] := W[I-1];
    IND[I+0] := IND[I-1];
_26:
   end;
_27:
  W[L-1] := RV5[K-1];
  IND[L-1] := TAG;
  K := K+1;
  goto _29;
_28:
  J := J+1;
_29:
 end;
_30:
if ( Q < N ) 
 then goto _5;
goto _32;
{  ********** }
_31:
IERR := 3*N+1;
_32:
LB := T1;
UB := T2;
end;

end.
